routes/web.php
<?php

use App\Http\Controllers\AssignTaskController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\GrantNewTokenController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\RequestTokenController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\TrashedClientController;
use App\Http\Controllers\TrashedProjectController;
use App\Http\Controllers\TrashedTaskController;
use App\Http\Controllers\TrashedUserController;
use App\Http\Controllers\UnassignTaskController;
use App\Http\Controllers\UpdatePasswordController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;
use Symfony\Component\HttpKernel\Profiler\Profile;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes(['register' => false]);

Route::redirect('/', 'login');

Route::middleware(['guest'])->group(function() {
    Route::controller(ChangePasswordController::class)->prefix('/change-password')->group(function () {
        Route::get('/{token}', 'create')->name('change-password.create');
        Route::post('/', 'store')->name('change-password.store');
    });

    Route::controller(RequestTokenController::class)->prefix('/request-token')->group(function () {
        Route::get('/{token}', 'create')->name('request-token.create');
        Route::post('/', 'store')->name('request-token.store');
    });
});


Route::middleware(['auth', 'password_not_changed'])->group(function (){
    Route::get('/dashboard', DashboardController::class)->name('dashboard');
    Route::post('/new_password', [UpdatePasswordController::class, 'store'])->name('new-password.store');

    Route::controller(ProfileController::class)->prefix('/profiles/{user}')->group(function (){
        Route::get('/', 'show')->name('profiles.show');
        Route::get('/edit', 'edit')->name('profiles.edit');
        Route::put('/', 'update')->name('profiles.update');
    });

    Route::resource('users', UserController::class);
    Route::patch('/users/{user}/restore', [UserController::class, 'restore'])->withTrashed()->name('users.restore');
    Route::post('users/{user}/token', GrantNewTokenController::class)->name('users.new-token');

    Route::resource('clients', ClientController::class);
    Route::patch('/clients/{client}/restore', [ClientController::class, 'restore'])->withTrashed()->name('clients.restore');
    Route::patch('/clients/{client}/forcedelete', [ClientController::class, 'forceDelete'])->withTrashed()->name('clients.force-delete');
    
    Route::resource('projects', ProjectController::class);
    Route::patch('/projects/{project}/restore', [ProjectController::class, 'restore'])->withTrashed()->name('projects.restore');
    Route::patch('/projects/{project}/forcedelete', [ProjectController::class, 'forceDelete'])->withTrashed()->name('projects.force-delete');

    Route::resource('tasks', TaskController::class);
    Route::patch('/tasks/{task}/restore', [TaskController::class, 'restore'])->withTrashed()->name('tasks.restore');
    Route::patch('/tasks/{task}/forcedelete', [TaskController::class, 'forceDelete'])->withTrashed()->name('tasks.force-delete');
    Route::patch('/tasks/{task}/unassign', UnassignTaskController::class)->name('tasks.unassign');
    Route::patch('/tasks/{task}/assign', AssignTaskController::class)->name('tasks.self-assign');

    Route::get('/trashed/projects', TrashedProjectController::class)->name('projects.trashed');
    Route::get('/trashed/clients', TrashedClientController::class)->name('clients.trashed');
    Route::get('/trashed/tasks', TrashedTaskController::class)->name('tasks.trashed');
    Route::get('/trashed/users', TrashedUserController::class)->name('users.trashed');
});

resources/views/layouts/partials/header.blade.php
<header class="header header-sticky mb-4 border-bottom border-light">
    <div class="container-fluid">
        <a class="header-brand d-md-none" href="#">
            Laravel
        </a>

        <ul class="header-nav d-none d-md-flex">
            <li class="nav-item">
                <a class="nav-link" href="#">Dashboard</a>
            </li>
        </ul>
        <ul class="header-nav ms-auto"></ul>

        <ul class="header-nav mx-2">
            <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle" data-coreui-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">
                    {{ Auth::user()->name }}
                </a>
                <div class="dropdown-menu dropdown-menu-start pt-0">
                    <a class="dropdown-item" href="{{ route('profiles.show', auth()->user())}}">My profile</a>
                    <a class="dropdown-item" href="{{ route('logout') }}"
                            onclick="event.preventDefault(); 
                            document.getElementById('logout-form').submit();">
                        Logout
                    </a>

                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                        @csrf
                    </form>
                </div>
            </li>
        </ul>
    </div>
</header>

resources/views/layouts/partials/sidebar.blade.php
<div class="sidebar sidebar-dark sidebar-fixed" id="sidebar">
    <div class="sidebar-brand d-none d-md-flex">
        {{ config('app.name', 'Laravel') }}
    </div>

    <ul class="sidebar-nav" data-coreui="navigation" data-simplebar>
        <li class="nav-item">
            <a class="nav-link" href="{{ route('dashboard') }}">Dashboard</a>
        </li>

        @can('read_user')
            <li class="nav-item nav-group">
                <a class="nav-link nav-group-toggle" href="#">
                    Users
                </a>

                <ul class="nav-group-items">
                    <li class="nav-item">
                        <a class="nav-link" href="{{ route('users.index') }}">
                            User overview
                        </a>
                    </li>

                    @can('create_user')
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('users.create') }}">
                                Create User
                            </a>
                        </li>
                    @endcan

                    @if (auth()->user()->can('read_trashed') && auth()->user()->can('read_users'))
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('users.trashed') }}">
                                Discarded users
                            </a>
                        </li>
                    @endif
                </ul>
            </li>
        @endcan

        @can('read_client')
            <li class="nav-item nav-group">
                <a class="nav-link nav-group-toggle" href="#">
                    Clients
                </a>

                <ul class="nav-group-items">
                    <li class="nav-item">
                        <a class="nav-link" href="{{ route('clients.index') }}">
                            Client Overview
                        </a>
                    </li>

                    @can('create_client')
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('clients.create') }}">
                                Create Client
                            </a>
                        </li>
                    @endcan
                    @if (auth()->user()->can('read_trashed') && auth()->user()->can('read_client'))
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('clients.trashed') }}">
                                Discarded Clients
                            </a>
                        </li>
                    @endif
                </ul>
            </li>
        @endcan

        @can('read_project')
            <li class="nav-item nav-group">
                <a class="nav-link nav-group-toggle" href="#">
                    Projects
                </a>

                <ul class="nav-group-items">
                    <li class="nav-item">
                        <a class="nav-link" href="{{ route('projects.index') }}">
                            Project Overview
                        </a>
                    </li>

                    @can('create_project')
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('projects.create') }}">
                                Create Project
                            </a>
                        </li>
                    @endcan

                    @if (auth()->user()->can('read_trashed') && auth()->user()->can('read_project'))
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('projects.trashed') }}">
                                Discarded Projects
                            </a>
                        </li>
                    @endif
                </ul>
            </li>
        @endcan

        @can('read_task')
            <li class="nav-item nav-group">
                <a class="nav-link nav-group-toggle" href="#">
                    Tasks
                </a>

                <ul class="nav-group-items">
                    <li class="nav-item">
                        <a class="nav-link" href="{{ route('tasks.index') }}">
                            Task Overview
                        </a>
                    </li>

                    @can('create_task')
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('tasks.create') }}">
                                Create Task
                            </a>
                        </li>
                    @endcan

                    @if (auth()->user()->can('read_trashed') && auth()->user()->can('read_task'))
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('tasks.trashed') }}">
                                Trashed Tasks
                            </a>
                        </li>
                    @endif
                </ul>
            </li>
        @endcan
    </ul>
</div>